<?php

function GetCountHmisPatientNursing()
{

    $strSearch = System::GetValue('search', '');

    $objDb = QApplication::$Database[1];
    $strSearch = pg_escape_string(strtoupper($strSearch));
    //$strSearch = '1';

    $strOption = System::GetValue('option',null);
    if($strOption=='9'){
        $strTablename = 'hmis_patient_nursing_active';
    } else {
        $strTablename = 'hmis_patient_nursing';
    }

    $dtStartDate = System::GetValue('start_date',null,'date');
    $dtStartTime = System::GetValue('start_time',null,'date');
    $dtEndDate = System::GetValue('end_date',null,'date');
    $dtEndTime = System::GetValue('end_time',null,'date');

    $WHERE = "
         WHERE
              hmis_patient_nursing.state <> 'D'
            AND (
                UPPER(hmis_patient_nursing.full_name) LIKE '%$strSearch%'
                OR UPPER(hmis_patient_nursing.first_name) LIKE '%$strSearch%'
                OR UPPER(hmis_patient_nursing.family_name) LIKE '%$strSearch%'
                OR UPPER(hmis_patient_nursing.mr) LIKE '%$strSearch%'
            )
    ";
    /*
    if($strOption!='9'){
        $WHERE = $WHERE . "
            AND (
              ( nursing_start_date BETWEEN '".$dtStartDate->PhpDate('Y-m-d')."' AND '".$dtEndDate->PhpDate('Y-m-d')."' )
            )
            AND (
              ( on_partition BETWEEN '".$dtStartDate->PhpDate('Y-m-d')."' AND '".$dtEndDate->PhpDate('Y-m-d')."' )
            )
        ";
    }
    */

    $strSql = "
		   SELECT COUNT(hmis_patient_nursing.id) AS jumlah
		   FROM $strTablename AS hmis_patient_nursing
		   $WHERE
	";

    // System::WriteLog('x-test-point-1-count.txt',$strSql);
    $objDbResult = $objDb->Query($strSql);

    $strDbRow = $objDbResult->FetchRow();
    return $strDbRow[0];
}

function GetHmisPatientNursing()
{

    $dtStartDate = System::GetValue('start_date',QDateTime::Now(),'date');
    $dtStartTime = System::GetValue('start_time',QDateTime::Now(),'time');
    $dtEndDate = System::GetValue('end_date',QDateTime::Now(),'date');
    $dtEndTime = System::GetValue('end_time',QDateTime::Now(),'time');

    $strSearch = System::GetValue('search', '');

    $intStart = System::GetValue('start', 0);
    $intLimit = System::GetValue('limit', 20);

    $strSortField = System::GetValue('sort', '');
    $sort_dir = System::GetValue('dir', 'ASC');

    $objDb = QApplication::$Database[1];
    $strSearch = pg_escape_string(strtoupper($strSearch));
    //$strSearch = '1';

    $strOption = System::GetValue('option',null);
    if($strOption=='9'){
        $strTablename = 'hmis_patient_nursing_active';
    } else {
        $strTablename = 'hmis_patient_nursing';
    }

    $dtStartDate = System::GetValue('start_date',null,'date');
    $dtStartTime = System::GetValue('start_time',null,'date');
    $dtEndDate = System::GetValue('end_date',null,'date');
    $dtEndTime = System::GetValue('end_time',null,'date');

    $WHERE = "
         WHERE
              hmis_patient_nursing.state <> 'D'
            AND (
                UPPER(hmis_patient_nursing.full_name) LIKE '%$strSearch%'
                OR UPPER(hmis_patient_nursing.first_name) LIKE '%$strSearch%'
                OR UPPER(hmis_patient_nursing.family_name) LIKE '%$strSearch%'
                OR UPPER(hmis_patient_nursing.mr) LIKE '%$strSearch%'
            )
    ";
    /*
    if($strOption!='9'){
        $WHERE = $WHERE . "
            AND (
              ( nursing_start_date BETWEEN '".$dtStartDate->PhpDate('Y-m-d')."' AND '".$dtEndDate->PhpDate('Y-m-d')."' )
            )
            AND (
              ( on_partition BETWEEN '".$dtStartDate->PhpDate('Y-m-d')."' AND '".$dtEndDate->PhpDate('Y-m-d')."' )
            )
        ";
    }
    */

    $SORT = '';
    if (isset($strSortTipe) && isset($strSortField)) {
        if ($strSortField == 'Id') {
            $SORT = "ORDER BY hmis_patient_nursing.id $strSortTipe";
        } else if ($strSortField == 'FirstName') {
            $SORT = "ORDER BY hmis_patient_nursing.first_name $strSortTipe";
        }
    }
    if($SORT==''){$SORT = "ORDER BY hmis_patient_nursing.create_time DESC";}

    $strTablename = 'hmis_patient_nursing_active';
    $strSql = "
			SELECT
			    hmis_patient_nursing.*
                -- , convert_to_json(hmis_patient_nursing.profile_json)->>'StartCheckinDepartmentId' as checkin_department_id
			    -- , convert_to_json(hmis_patient_nursing.profile_json)->>'TransferDepartmentId' as transfer_department_id
			    , convert_to_json( regexp_replace( hmis_patient_nursing.profile_json , '\\\\u....' , '' , 'g' ) )->>'StartCheckinDepartmentId' as checkin_department_id
			    , convert_to_json( regexp_replace( hmis_patient_nursing.profile_json , '\\\\u....' , '' , 'g' ) )->>'TransferDepartmentId' as transfer_department_id
			    , hmis_patient_nursing.create_time::date AS create_at_date
			    , hmis_patient_nursing.create_time::time AS create_at_time
			    , hmis_patient_nursing.modify_time::date AS update_at_date
			    , hmis_patient_nursing.modify_time::time AS update_at_time
			FROM $strTablename AS hmis_patient_nursing
			$WHERE
			$SORT
			LIMIT $intLimit OFFSET $intStart
	";

    // System::WriteLog('x-test-point-2-data.txt',$strSql);
    $objDbResult = $objDb->Query($strSql);

    if ($objDbResult->CountRows() > 0) {
        $u = array(); $arrayId = array();
        $i = 0;
        while ($row = $objDbResult->FetchArray()) {

            if(!(in_array( $row['patient_id'], $arrayId ))) {

            // if($row['nursing_category']=='3'){ array_push($arrayId,$row['patient_id']); }

            $objPatientNursing = HmisPatientNursing::DirectRowRead($row);

            $u[$i]['Id'] = $row['id'];
            $u[$i]['OnPartition'] = $row['on_partition'];

            $u[$i]['ActivityOnPartition'] = $row['activity_on_partition'];
            $u[$i]['ActivityId'] = $row['activity_id'];

            $u[$i]['PatientId'] = $row['patient_id'];
            $u[$i]['Mr'] = $row['mr'];

            $u[$i]['EmployeeNumber'] = $row['employee_number'];
            $u[$i]['IdentityNumber'] = $row['identity_number'];
            $u[$i]['FamilyNumber'] = $row['family_number'];
            $u[$i]['DomicilyAddress'] = $row['domicily_address'];            

            $strPatientName = '';
            if ($objPatientNursing->DateOfBirth) {
                $umur = $objPatientNursing->NursingStartDate->Timestamp - $objPatientNursing->DateOfBirth->Timestamp;
                if ($umur < 365 * 24 * 3600) {
                    $find_letters = array('BY.', '.BY', 'BY,', ',BY', 'BY ', ' BY');
                    $title = '.BY.NY';
                } elseif ($umur >= 365 * 24 * 3600 && $umur < 15 * 365 * 24 * 3600) {
                    $find_letters = array('AN.', '.AN', 'AN,', ',AN', 'AN ', ' AN');
                    $title = '.AN';
                } elseif ($umur >= 15 * 365 * 24 * 3600 && $umur < 20 * 365 * 24 * 3600) {
                    if ($objPatientNursing->Gender == "MALE") {
                        $find_letters = array('SDR.', '.SDR', 'SDR,', ',SDR', 'SDR ', ' SDR');
                        $title = '.SDR';
                    } else {
                        $find_letters = array('SDRI.', '.SDRI', 'SDRI', 'SDRI,', ',SDRI', 'SDRI ', ' SDRI');
                        $title = '.SDRI';
                    }
                } elseif ($umur >= 20 * 365 * 24 * 3600) {
                    if ($objPatientNursing->Gender == "MALE") {
                        $find_letters = array('TN.', '.TN', 'TN,', ',TN', 'TN ', ' TN');
                        $title = '.TN';
                    } else {
                        $find_letters = array('NY.', '.NY', 'NY,', ',NY', 'NY ', ' NY');
                        $title = '.NY';
                    }
                }
                $flag = false;
                foreach ($find_letters as $letter) {
                    if (stripos($objPatientNursing->FirstName, $letter) > 0) {
                        $flag = true;
                        break;
                    }
                }
                $strPatientName = $objPatientNursing->FirstName;
                if (!$flag) {
                    $strPatientName = $objPatientNursing->FirstName . ' ' . $title;
                }
            }

            $u[$i]['FullName'] = strtoupper( ( $row['full_name'] ? $row['full_name']: $row['first_name'] ) . ( $row['title_name'] ? ', '.$row['title_name']:'' ) );
            $u[$i]['FirstName'] = strtoupper( $row['first_name'] );
            $u[$i]['FamilyName'] = strtoupper( $row['family_name'] );
            $u[$i]['TitleName'] = strtoupper( $row['title_name'] );

            if(strlen($strPatientName)){
                $u[$i]['FullName'] = strtoupper( $strPatientName );
                $u[$i]['FirstName'] = strtoupper( $strPatientName );
            }

            $u[$i]['Gender'] = $row['gender'];
            $u[$i]['PlaceOfBirth'] = $row['place_of_birth'];
            $u[$i]['DateOfBirth'] = $row['date_of_birth'];
            $u[$i]['PrimaryICD'] = $row['admission_diagnose_description_1'];
            $u[$i]['KodeICD'] = $row['admission_diagnose_code_1'];
            
            $u[$i]['SecondaryICD'] = $row['admission_diagnose_description_2'];
            $u[$i]['KodeICDSekunder'] = $row['admission_diagnose_code_2'];
            

            $u[$i]['DomicilyAddress'] = $row['domicily_address'];            
            $u[$i]['FullAddress'] = $row['address'] ? $row['address'].($row['area_description']? (' , '.$row['area_description']): ''): $row['area_description'] ;
            $u[$i]['Address'] = $row['address'];
            $u[$i]['HouseNumber'] = $row['house_number'];
            $u[$i]['BlockNumber'] = $row['block_number'];
            $u[$i]['AreaNumber'] = $row['area_number'];

            $u[$i]['AreaDescription'] = $row['area_description'];

            $u[$i]['VillageName'] = $row['village_name'];
            $u[$i]['VillageCode'] = $row['village_code'];
            $u[$i]['VillageId'] = $row['village_id'];

            $u[$i]['SubDistrictName'] = $row['sub_district_name'];
            $u[$i]['SubDistrictCode'] = $row['sub_district_code'];
            $u[$i]['SubDistrictId'] = $row['sub_district_id'];

            $u[$i]['DistrictName'] = $row['district_name'];
            $u[$i]['DistrictCode'] = $row['district_code'];
            $u[$i]['DistrictId'] = $row['district_id'];

            $u[$i]['ProvinceName'] = $row['province_name'];
            $u[$i]['ProvinceCode'] = $row['province_code'];
            $u[$i]['ProvinceId'] = $row['province_id'];

            $u[$i]['Country'] = $row['country'];

            $u[$i]['City'] = $row['city'];
            $u[$i]['DomicilyAddress'] = $row['domicily_address'];
            $u[$i]['Postal'] = $row['postal'];

            $u[$i]['MobilePhone'] = $row['mobile_phone'];
            $u[$i]['HomePhone'] = $row['home_phone'];
            $u[$i]['OfficePhone'] = $row['office_phone'];
            $u[$i]['Email'] = $row['email'];

            $u[$i]['EducationDegree'] = $row['education_degree_description'];
            $u[$i]['Occupation'] = $row['occupation_description'];
            $u[$i]['Ethnic'] = $row['ethnic_description'];
            $u[$i]['Religion'] = $row['religion_description'];

            $u[$i]['MaritalState'] = $row['marital_state_description'];
            $u[$i]['PairName'] = $row['pair_name'];

            $u[$i]['MotherName'] = $row['mother_name'];
            $u[$i]['MotherIdentityNumber'] = $row['mother_identity_number'];
            $u[$i]['MotherAddress'] = $row['mother_address'];
            $u[$i]['MotherPhone'] = $row['mother_phone'];

            $u[$i]['FatherName'] = $row['father_name'];
            $u[$i]['FatherIdentityNumber'] = $row['father_identity_number'];
            $u[$i]['FatherAddress'] = $row['father_address'];
            $u[$i]['FatherPhone'] = $row['father_phone'];

            $u[$i]['EmergencyContact'] = $row['emergency_contact'];
            $u[$i]['EmergencyContactRelation'] = $row['emergency_contact_relation'];
            $u[$i]['EmergencyContactAddress'] = $row['emergency_contact_address'];
            $u[$i]['EmergencyContactPhone'] = $row['emergency_contact_phone'];

            $u[$i]['PaymentPayer'] = $row['payment_payer'];
            $u[$i]['PaymentPayerRelation'] = $row['payment_payer_relation'];
            $u[$i]['PaymentPayerAddress'] = $row['payment_payer_address'];
            $u[$i]['PaymentPayerPhone'] = $row['payment_payer_phone'];

            $u[$i]['BloodGroup'] = $row['blood_group'];
            $u[$i]['BloodRhesus'] = $row['blood_rhesus'];

            $u[$i]['HistoryOfFamilialDisease'] = $row['history_of_familial_disease'];
            $u[$i]['HistoryOfAllergies'] = $row['history_of_allergies'];
            $u[$i]['HistoryOfSurgeryProcedure'] = $row['history_of_surgery'];

            $u[$i]['NursingStartDate'] = $row['nursing_start_date'];
                        $u[$i]['NursingStartDateTime'] = $row['nursing_start_date_time'];

            $u[$i]['BillingCategory'] = $row['billing_category'];

            $u[$i]['ContractServiceName'] = $row['contract_service_name'];
            $u[$i]['ContractServiceCode'] = $row['contract_service_code'];
            $u[$i]['ContractServiceId'] = $row['contract_service_id'];

            $u[$i]['BillingToName'] = $row['billing_to_name'];
            $u[$i]['BillingToCode'] = $row['billing_to_code'];
            $u[$i]['BillingToId'] = $row['billing_to_id'];

            $u[$i]['InsuranceContractServiceName'] = $row['insurance_contract_service_name'];
            $u[$i]['InsuranceContractServiceCode'] = $row['insurance_contract_service_code'];
            $u[$i]['InsuranceContractServiceId'] = $row['insurance_contract_service_id'];

            $u[$i]['InsuranceName'] = $row['insurance_name'];
            $u[$i]['InsuranceCode'] = $row['insurance_code'];
            $u[$i]['InsuranceId'] = $row['insurance_id'];

            $u[$i]['CompanyContractServiceName'] = $row['company_contract_service_name'];
            $u[$i]['CompanyContractServiceCode'] = $row['company_contract_service_code'];
            $u[$i]['CompanyContractServiceId'] = $row['company_contract_service_id'];

            $u[$i]['CompanyName'] = $row['company_name'];
            $u[$i]['CompanyCode'] = $row['company_code'];
            $u[$i]['CompanyId'] = $row['company_id'];

            $u[$i]['PatientCategory'] = $row['patient_category'];
            $u[$i]['NursingCategory'] = $row['nursing_category'];
            $u[$i]['NursingType'] = $row['nursing_type'];

            $u[$i]['DepartmentName'] = $row['department_name'];
            $u[$i]['DepartmentCode'] = $row['department_code'];
            $u[$i]['DepartmentId'] = $row['department_id'];

 $u[$i]['PresentClassName'] = $row['present_class_name'];

            if($row['department_id']) {
                // System::WriteLog('x-list-DepartmentId.txt',$row['department_id']);
                $strDepartmentName = $row['department_name'];
                $strDepartmentCode = $row['department_code'];
                $strDepartmentId = $row['department_id'];
            } else if( !empty($row['checkin_department_id']) ) {
                // System::WriteLog('x-list-StartCheckinDepartmentId.txt',$row['checkin_department_id']);
                $objDepartment = HmisRefDepartment::LoadById($row['checkin_department_id']);
                $strDepartmentName = $objDepartment->Name.'***';
                $strDepartmentCode = $objDepartment->Code;
                $strDepartmentId = $objDepartment->Id;
            } else if( !empty($row['transfer_department_id']) ) {
                // System::WriteLog('x-list-TransferDepartmentId.txt',$row['transfer_department_id']);
                $objDepartment = HmisRefDepartment::LoadById($row['transfer_department_id']);
                $strDepartmentName = $objDepartment->Name.'***';
                $strDepartmentCode = $objDepartment->Code;
                $strDepartmentId = $objDepartment->Id;
            }

            $u[$i]['DepartmentName'] = $strDepartmentName;
            $u[$i]['DepartmentCode'] = $strDepartmentCode;
            $u[$i]['DepartmentId'] = $strDepartmentId;
                        $u[$i]['DomicilyAddress'] = $row['domicily_address'];            

            $u[$i]['NursingStartDate'] = $row['nursing_start_date'];

            $u[$i]['DoctorName'] = $row['doctor_name'];
            $u[$i]['DoctorCode'] = $row['doctor_code'];
            $u[$i]['DoctorId'] = $row['doctor_id'];

            $u[$i]['CompetenceName'] = $row['competence_name'];
            $u[$i]['CompetenceCode'] = $row['competence_code'];
            $u[$i]['CompetenceId'] = $row['competence_id'];

            // $u[$i]['State'] = $row['nursing_category'].' # '.$row['current_state'];

            $u[$i]['State'] = '1';
            if( $row['nursing_category'] == 1 ) { // RJ
                if( $row['current_state'] == 4 ) {
                    $u[$i]['StateNotes'] = 'Selesai';
                } else {
                    $u[$i]['StateNotes'] = $row['current_state'];
                    $u[$i]['StateNotes'] = '-';
                }
            } elseif ($row['nursing_category'] == 2 ) { // RD
                if( $row['current_state'] == 4 ) {
                    $u[$i]['StateNotes'] = 'Selesai';
                    $u[$i]['State'] = '0';
                } else {
                    $u[$i]['StateNotes'] = $row['current_state'];
                    $u[$i]['StateNotes'] = '-';
                }
            } elseif ($row['nursing_category'] == 3 ) { // RI
                if( $row['current_state'] == 5 ) {
                    $u[$i]['StateNotes'] = 'Selesai';
                    $u[$i]['State'] = '0';
                } else {
                    $u[$i]['StateNotes'] = $row['current_state'];
                    $u[$i]['StateNotes'] = '-';
                }
            }

            $objPatient = HmisRefPatient::LoadById($row['patient_id']);
            $u[$i]['CheckStatusTagihan'] = System::getStatusAdmissionCheckStatusTagihan();
            $u[$i]['StatusTagihan'] = $objPatient->StatusTagihan;
            if( $u[$i]['CheckStatusTagihan']=='1' ) {
                if ( $u[$i]['StatusTagihan'] != 'AKTIF' ) {
                    $u[$i]['StateNotes'] = 'Selesai';
                    $u[$i]['State'] = '0'; // Tidak diijinkan Transaksi
                } else {
                    $u[$i]['StateNotes'] = 'Aktif';
                    $u[$i]['State'] = '0'; // Tidak diijinkan Transaksi
                }
            }

            $u[$i]['KodeBooking'] = $objPatientNursing->KodeBooking;

            // $u[$i]['State'] = $row['nursing_category'].' # '.$row['current_state'];
            $u[$i]['CreateAtDate'] = $row['create_at_date'];
            $u[$i]['CreateAtTime'] = $row['create_at_time'];
            $u[$i]['UpdateAtDate'] = $row['update_at_date'];
            $u[$i]['UpdateAtTime'] = $row['update_at_time'];
            $i++;

            }
        }
        return $u;
    }	else {
        return 0;
    }
}

function getAge($current,$dateofbirth)
{
    if(version_compare(PHP_VERSION, '5.3.0') >= 0){
        $dob = new DateTime($dateofbirth);
        $now = new DateTime($current);
        return $now->diff($dob)->d;
    }
    $dob = strtotime($dateofbirth);
    $now = strtotime($current);
    $difference = $now - $dob;
    $age = floor($difference/(60*60*24));
    return $age;
}

// ============================================================================================= //
// Main	Service																					 //
// ============================================================================================= //

function service()
{
    $strState = System::GetValue('state','');
    $strOption = System::GetValue('option','');
    if( $strState ) {
        if($strState == 'request_data')
        {
            if(isset($_POST['start']) || isset($_GET['start']) ){
                // System::WriteLog('x-test-point-1.txt','');
                // System::startProfiling('query-patient-nursing-out-patient');
                $objDataCount = GetCountHmisPatientNursing(); $objDataset = GetHmisPatientNursing();
                // System::saveProfiling('query-patient-nursing-out-patient');
                return System::ResultRecordset($objDataset, $objDataCount);
            }
        }
        return '';
    }
    return '';
}

// ============================================================================================= //

// System::WriteLog('x-test-point-0.txt','');

// ============================================================================================= //

echo service();

// ============================================================================================= //

?>
